
#include 'S3d.au3'
#include <Array.au3>

 ; Startanzahl
Global $iSpheresStart = 3

Opt('GUIOnEventMode', 1)
_GDIPlus_Startup()

Global $bExit = False, $iCnt = 0, $aSpheres[0][3], $bAddSphere = False, $bDelSphere = False, $iSpheres = 0, $bRotieren = False


Global $iW = 500, $iH = 500
Global $hGUI = GUICreate('Kugeloberflche', $iW + 100, $iH)
Global $hBTN_Add = GUICtrlCreateButton('Add', $iW + 10, 20, 80, 25)
GUICtrlSetOnEvent(-1, 'BtnAdd')
Global $hBTN_Del = GUICtrlCreateButton('Del', $iW + 10, 45, 80, 25)
GUICtrlSetOnEvent(-1, 'BtnDel')
Global $hBTN_Rot = GUICtrlCreateButton('Rotieren', $iW + 10, 200, 80, 25)
GUICtrlSetOnEvent(-1, 'BtnRot')

GUICtrlCreateEdit('Min. Abstand', $iW + 10, 80, 80, 20, 2049)
Global $hLAB_ABS = GUICtrlCreateEdit('', $iW + 10, 105, 80, 20, 2049)
GUICtrlCreateEdit('Anzahl', $iW + 10, 130, 80, 20, 2049)
Global $hLAB_ANZ = GUICtrlCreateEdit('', $iW + 10, 155, 80, 20, 2049)

Global $hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
Global $hBMP = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGFX)
Global $hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
Global $hPEN = _GDIPlus_PenCreate(0xFF204080)
Global $hBRU = _GDIPlus_BrushCreateSolid(0x804080FF)
Global $hBRU2 = _GDIPlus_BrushCreateSolid(0x30FF8040)

_S3d_SelectGraphic($hBUF, $iW, $iH)
_S3d_SelectPen($hPEN)
_S3d_SelectBrush($hBRU)
GUISetOnEvent(-3, '_Exit')

For $i = 0 To $iSpheresStart - 1 Step 1
	AddSphere($aSpheres)
Next

_S3d_SetCamera(3 * Cos($iCnt/100), 3 * Sin($iCnt/100), 0, 0, 0, 0)
Update($hLAB_ANZ, $iSpheres)
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit

	If $bAddSphere Then
		$bAddSphere = False
		AddSphere($aSpheres)
		Update($hLAB_ANZ, $iSpheres)
	EndIf

	If $bDelSphere Then
		$bDelSphere = False
		DelSphere($aSpheres)
		Update($hLAB_ANZ, $iSpheres)
	EndIf

	_S3d_Clear(0xFF111111)
	If $bRotieren Then
		 Add($iCnt, 1)
		_S3d_SetCamera(3 * Cos($iCnt/100), 3 * Sin($iCnt/100), 0, 0, 0, 0)
	EndIf
	_S3d_SelectBrush($hBRU)
	For $i = 0 To $iSpheres - 1 Step 1
		_S3d_Circle($aSpheres[$i][0], $aSpheres[$i][1], $aSpheres[$i][2], 0.02, True)
	Next

	_S3d_SelectBrush($hBRU2)
	_S3d_Circle(0, 0, 0, 0.45, True)

	$iCalcTimer = TimerInit()
	While TimerDiff($iCalcTimer) < 10 ; 10ms Rechenzeit/Frame
		Calc($aSpheres)
	WEnd

;~ 	ConsoleWrite(TimerDiff($iCalcTimer) & @CRLF)
	_GDIPlus_GraphicsDrawImage($hGFX, $hBMP, 0, 0)
;~ 	Sleep(10)
WEnd

_GDIPlus_BrushDispose($hBRU2)
_GDIPlus_BrushDispose($hBRU)
_GDIPlus_PenDispose($hPen)
_GDIPlus_GraphicsDispose($hBUF)
_GDIPlus_BitmapDispose($hBMP)
_GDIPlus_GraphicsDispose($hGFX)

Func Calc(ByRef $aSpheres)
	Local $u = UBound($aSpheres), $aNew[$u][3], $aVec, $iLen, $aTmp, $iAbstMin = 999
	Local Static $iDTimer = TimerInit()
	For $i = 0 To $u - 1 Step 1
		$aTmp = CalcAbs($aSpheres, $i)
		$aVec = $aTmp[0]
		If $aTmp[1] < $iAbstMin Then $iAbstMin = $aTmp[1]
		$iLen = 0
		For $n = 0 To 2 Step 1
			$aNew[$i][$n] = $aSpheres[$i][$n] + $aVec[$n]/1000
			$iLen += $aNew[$i][$n]^2
		Next
		For $n = 0 To 2 Step 1
			$aNew[$i][$n] /= $iLen^0.5
		Next
;~ 		ConsoleWrite('l' & $i & ': ' & ($aNew[$i][0]^2 + $aNew[$i][1]^2 + $aNew[$i][2]^2)^0.5 & @CRLF)
;~ 		ConsoleWrite('x: ' & $aVec[0] & @CRLF & 'y: ' & $aVec[1] & @CRLF & 'z: ' & $aVec[2] & @CRLF & @CRLF)
	Next

	If TimerDiff($iDTimer) > 1000 Then
		$iDTimer = TimerInit()
		Update($hLAB_ABS, String(Round($iAbstMin, 8)))
	EndIf


	$aSpheres = $aNew
EndFunc

Func CalcAbs(ByRef $aSpheres, $e)
	Local $aVec = [0, 0, 0], $iAbst, $iAbstMin = 999
	For $i = 0 To UBound($aSpheres) - 1 Step 1
		If $i <> $e Then
			$iAbst = (($aSpheres[$e][0] - $aSpheres[$i][0])^2 + ($aSpheres[$e][1] - $aSpheres[$i][1])^2 + ($aSpheres[$e][2] - $aSpheres[$i][2])^2)^0.5
			If $iAbst < $iAbstMin Then $iAbstMin = $iAbst
			$aVec[0] -= ($aSpheres[$i][0] - $aSpheres[$e][0])/$iAbst
			$aVec[1] -= ($aSpheres[$i][1] - $aSpheres[$e][1])/$iAbst
			$aVec[2] -= ($aSpheres[$i][2] - $aSpheres[$e][2])/$iAbst
		EndIf
	Next
	Local $aTmp = [$aVec, $iAbstMin]
	Return $aTmp
EndFunc

Func Update($iCtrl, $sData)
	If GUICtrlRead($iCtrl) <> $sData Then GUICtrlSetData($iCtrl, $sData)
EndFunc

Func DelSphere(ByRef $aSpheres)
	Local $u = UBound($aSpheres)
	If $u > 1 Then
		ReDim $aSpheres[$u - 1][3]
		$iSpheres -= 1
	EndIf
EndFunc

Func BtnAdd()
	$bAddSphere = True
EndFunc

Func BtnDel()
	$bDelSphere = True
EndFunc

Func BtnRot()
	$bRotieren = Not $bRotieren
EndFunc

Func AddSphere(ByRef $aSpheres)
	Local $u = UBound($aSpheres)
	ReDim $aSpheres[$u + 1][3]
	Local $r = 1, $pol = Random(0, 180), $azi = Random(0, 360)
	$aSpheres[$u][0] = $r * _Sin($pol) * _Cos($azi)
	$aSpheres[$u][1] = $r * _Sin($pol) * _Sin($azi)
	$aSpheres[$u][2] = $r * _Cos($pol)
	$iSpheres += 1
EndFunc

Func _Sin($n) ; 0 -> 360
	Return Sin($n * $__S3d_PI / 180)
EndFunc

Func _Cos($n) ; 0 -> 360
	Return Cos($n * $__S3d_PI / 180)
EndFunc

Func _Exit()
	$bExit = True
EndFunc

Func Add(ByRef $iVar, $i)
	$iVar += $i
	Return True
EndFunc